/*================================================================================================*
 * Поддержка часов реального времени
 *================================================================================================*/

#ifndef RTC_H_
#define RTC_H_

#include "global.h"
#include "settings.h"

/*================================================================================================*/
#define RTC_SUPPORT_ENABLED SET_RTC_ENABLE

#define RTC_CALIB_UNCHANGED INT32_MIN   /* Значение rtc_time_t.calib, означающее "не менять" */

typedef struct __attribute__ ((packed))
    {
    uint16_t year;      /* год (4-значный) */
    uint8_t month;      /* месяц, 1..12 */
    uint8_t dow;        /* день недели (0 = вс, 6 = сб) */
    uint8_t day;        /* день месяца, 1..31 */
    uint8_t hour;       /* час, 0..23 */
    uint8_t minute;     /* минута, 0..59 */
    uint8_t second;     /* секунда, 0..59 */
    int32_t calib;      /* поправочный коэффициент: 0 = нет,
                           +2..+131072 : +1с каждые n секунд
                           -2..-131072 : пропуск 1с каждые n секунд */
    }
    rtc_time_t;
/*================================================================================================*/

/*================================================================================================*/
#if RTC_SUPPORT_ENABLED
/*------------------------------------------------------------------------------------------------*/
void rtc_init                       /* Инициализация */
    (void);
/*------------------------------------------------------------------------------------------------*/
int rtc_get_time                    /* Чтение часов */
    (
    rtc_time_t* p_tm                /* (out) Текущее время */
    );                              /* Возвращает 1 = ok, 0 = ошибка */
/*------------------------------------------------------------------------------------------------*/
int rtc_set_prepare                 /* Подготовка к установке часов (остановка) */
    (void);                         /* Возвращает 1 = ok, 0 = ошибка */
/*------------------------------------------------------------------------------------------------*/
int rtc_ready_to_set                /* Проверка, что часы готовы к установке */
    (void);                         /* Возвращает 1 = ok, 0 = не готов или не было rtc_set_prepare */
/*------------------------------------------------------------------------------------------------*/
int rtc_set_time                    /* Установка часов после rtc_set_prepare(), rtc_ready_to_set() */
    (
    const rtc_time_t* p_tm          /* Устанавливаемое время (= текущее время + 1 с) */
    );                              /* Возвращает 1 = ok, 0 = ошибка */
/*------------------------------------------------------------------------------------------------*/
void rtc_worker                     /* Фоновая процедура */
    (void);
/*------------------------------------------------------------------------------------------------*/
#else /* else if !RTC_SUPPORT_ENABLED */
/* Если поддержка RTC выключена, код не компилируется, функции заменяются inline заглушками */
/*------------------------------------------------------------------------------------------------*/
static inline void rtc_init(void)                       { }
static inline int rtc_get_time(rtc_time_t* p_tm)        { return 0; }
static inline int rtc_set_prepare(void)                 { return 0; }
static inline int rtc_ready_to_set(void)                { return 0; }
static inline int rtc_set_time(const rtc_time_t* p_tm)  { return 0; }
static inline void rtc_worker(void)                     { }
/*------------------------------------------------------------------------------------------------*/
#endif /* RTC_SUPPORT_ENABLED */
/*================================================================================================*/
#endif /* RTC_H_ */
